##
##
##
## File defining the the bootstrap functions used throughout the algorithms
##
##
##



##
## Auxiliar function, that creates bootstrap set from the total set
##
## it receives the whole data 

getBootstrapBiased_k <- function( data = "data.frame", obs_index , k){
  
  if( ncol(data)> 1 ){
    
    bootstrap_data <- data[1:k,]   #alocar bootstrap data, data mantem-se igual, bootdata tem menosum elemento
    
    boot_indexes   <- sample(1:nrow(data),(k-1),replace=TRUE) 
    
    bootstrap_data[1:(k-1),]  <- data[boot_indexes,]
    
    bootstrap_data[k,]        <- data[obs_index,] 
    
    return(bootstrap_data)  
  }
  else{
    
    bootstrap_data <- data[1:k,]   #alocar bootstrap data, data mantem-se igual, bootdata tem menosum elemento
    
    boot_indexes   <- sample(1:nrow(data),(k-1),replace=TRUE) 
    
    bootstrap_data[1:(k-1)]  <- data[boot_indexes,]
    
    bootstrap_data[k]        <- data[obs_index,]  
    
    return(bootstrap_data)  
  }
  
  return(bootstrap_data)  
}  



## Modified bootstrap instead of returning n samples it only return k samples
## 
getBootstrap_K <- function( data = "data.frame" , k ){
  
  
  if( ncol(data)>1 ){
    
    bootstrap_data <- data[1:k,] #allocate boot data
    
    boot_indexes   <- sample(1:nrow(data),k,replace=TRUE)  
    bootstrap_data[1:k,] <- data[boot_indexes,]
    
  }
  else{
    
    bootstrap_data <- data[1:k] #allocate boot data
    
    boot_indexes   <- sample(1:nrow(data),k,replace=TRUE)  
    bootstrap_data[1:k] <- data[boot_indexes,]
    
  }
  
  return(bootstrap_data)
  
}  



##
## Auxiliar function, that creates bootstrap set from the total set
##
## it receives the whole data 

getBootstrapBiased_k2 <- function( data = "data.frame", obs_index , k){
  
  if( ncol(data)> 1 ){
    
    bootstrap_data <- data[1:k,]   #alocar bootstrap data, data mantem-se igual, bootdata tem menosum elemento
    
    boot_indexes   <- sample(1:nrow(data),(k-1),replace=TRUE) 
    
    bootstrap_data[1:(k-1),]  <- data[boot_indexes,]
    
    bootstrap_data[k,]        <- data[obs_index,] 
    
    out <- list(bootstrap_data,unique(boot_indexes))
    names(out) <- c("data","indexes")
    return(out )  
  }
  else{
    
    bootstrap_data <- data[1:k,]   #alocar bootstrap data, data mantem-se igual, bootdata tem menosum elemento
    
    boot_indexes   <- sample(1:nrow(data),(k-1),replace=TRUE) 
    
    bootstrap_data[1:(k-1)]  <- data[boot_indexes,]
    
    bootstrap_data[k]        <- data[obs_index,]  
    
    out <- list(bootstrap_data,unique(boot_indexes))
    names(out) <- c("data","indexes")
    return(out)  
  }
  
}  



## Modified bootstrap k=n-c , instead of returning n samples it  return k samples
## 


getBootstrap_K2 <- function( data = "data.frame" , k ){
  
  
  if( ncol(data)>1 ){
    
    bootstrap_data <- data[1:k,] #allocate boot data
    
    boot_indexes   <- sample(1:nrow(data),k,replace=TRUE)  
    bootstrap_data[1:k,] <- data[boot_indexes,]
    
  }
  else{
    
    bootstrap_data <- data[1:k,] #allocate boot data
    
    boot_indexes   <- sample(1:nrow(data),k,replace=TRUE)  
    bootstrap_data[1:k] <- data[boot_indexes,]
    
  }
  
  out <- list(bootstrap_data,unique(boot_indexes))
  names(out) <- c("data","indexes")
  return(out)  
  
}  


