#
# This file implements the three alternative methods considered in the Bioninformatics paper: 
#
#   1- Deviance Residuals
#
#

wod_coxdevianceresiduals <- function(dataset = "SurvivalDataSet" ){

  
  actual_data <- cbind( dataset@data , dataset@time_vector , dataset@status_vector )
  
  time_index   <- ncol(actual_data) - 1
  status_index <- ncol(actual_data)  
  
  cox_object  <- coxph( Surv(actual_data[,time_index], as.integer(actual_data[,status_index]) ) ~ .   , data = actual_data[,-c(time_index,status_index)] )
  
  
  ress <- resid(cox_object,type="deviance")
  ress <- data.frame(cbind(1:length(ress), abs(ress) ) )
  ordered_ress <- ress[ order( -ress[,2]) , ]

 
  
  return( ordered_ress )

}